/*
 *     SmoothAlgorithms.mqh  
 *   __\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                    Variation.mq5 | 
//|                                         Copyright  2010, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, LeMan."
#property link      "b-market@mail.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        Salmon
#property indicator_color1 Salmon
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----    
#property indicator_label1  "Variation"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 0.0
#property indicator_levelcolor Blue
#property indicator_levelstyle STYLE_SOLID
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int Period_=12;                     // 
input ENUM_MA_METHOD MA_Method_=MODE_SMA; //         
input int Shift=0;                        //     
//+-----------------------------------+
//----  
double ExtMapBuffer[];

int start=0;
double dPriceShift;
//+------------------------------------------------------------------+
//   Moving_Average                                    | 
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+   
//| Variation indicator initialization function                      | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----      
   SetIndexBuffer(0,ExtMapBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   if(MA_Method_!=MODE_EMA) start=2*Period_;
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,start);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"Variation");
//----      
   string shortname;
   StringConcatenate(shortname,"Variation( Period_ = ",Period_,", MA_Method_ = ",MA_Method_,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+ 
//| Variation iteration function                                     | 
//+------------------------------------------------------------------+ 
int OnCalculate
(
 const int rates_total,//       
 const int prev_calculated,//       
 const int begin,//     
 const double &price[]//     
 )
  {
//----
   start+=begin;
//----       
   if(rates_total<start) return(0);

//----   
   int first,bar;
//----       
   double ma1,ma2,ma3;
//----   
   static int start1,start2,start3;

//----     OnCalculate()
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      first=begin; //      

      //----     
      start1=begin;
      if(MA_Method_!=MODE_EMA)
        {
         start2 = Period_ + begin;
         start3 = start2 + Period_;
        }
      else
        {
         start2 = begin;
         start3 = begin;
        }

      //---      begin ,
      //---      
      if(begin>0) PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,start);
     }
   else first=prev_calculated-1; //      

//----    Moving_Average   SmoothAlgorithms.mqh
   static CMoving_Average MA1,MA2,MA3;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----    MASeries.  
      ma1 = MA1.MASeries(start1, prev_calculated, rates_total, Period_, MA_Method_, price[bar], bar, false);
      ma2 = MA2.MASeries(start2, prev_calculated, rates_total, Period_, MA_Method_, price[bar]-ma1, bar, false);
      ma3 = MA3.MASeries(start3, prev_calculated, rates_total, Period_, MA_Method_, price[bar]-ma2-ma1, bar, false);
      //----       
      ExtMapBuffer[bar]=ma3;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+